<?php
/*
Plugin Name: NaNoStats
Plugin URI: 
Description: Native up-to-date word count icon widget from the NaNoWriMo website via the NaNoWriMo Widgets Creator.
Author: Jerry Stephens
Version: 13.05.01
Author URI: http://www.codercorps.com
*/

  
function NaNoContent() 
{
  $options = get_option("widget_NaNoStats");
        $rooturl = 'http://nanowrimo.org/widget/';
//print_r($options);
$switch = $options['options']? ','.implode(',',$options['options']):'';
$widget = $rooturl.$options['img'].'/'.$options['username'].$switch.'.png';
echo '<img src="'.$widget.'" />';
}
 
function widget_NaNoStats($args) {
  extract($args);
 
  $options = get_option("widget_NaNoStats");
 
  echo $before_widget;
    echo $before_title;
      echo $options['title'];
    echo $after_title;
 
    //Our Widget Content
    NaNoContent();
  echo $after_widget;
}
 
function NaNoStats_control() 
{
  $option = get_option("widget_NaNoStats");
  $options = !is_array( $option ) ? array('title' => 'My NaNoWriMo Stats'):$option;     
 
  if ($_POST['NaNoStats-Submit']) 
  {
    $options['title'] = htmlspecialchars($_POST['NaNoStats-WidgetTitle']);
    $options['username'] = htmlspecialchars($_POST['NaNoStats-WidgetUser']);
    $options['img'] = htmlspecialchars($_POST['NaNoStats-WidgetImg']);
    $options['options'] = $_POST['NaNoStats-WidgetOptions'];
    update_option("widget_NaNoStats", $options);
  }
?>
  <p>
    <label for="NaNoStats-WidgetTitle">NaNoStats Title</label><br />
    <input type="text" id="NaNoStats-WidgetTitle" name="NaNoStats-WidgetTitle" value="<?php echo $options['title'];?>" /><br />
    <label for="NaNoStats-WidgetUser">NaNoWriMo User Name</label><br />
    <input type="text" id="NaNoStats-WidgetUser" name="NaNoStats-WidgetUser" value="<?php echo $options['username'];?>" /><br />
    <?php
        $widgets = array(
            'Participant Widget' => 'LiveParticipant',
            'Participant Widget With Username' => 'LiveSupporter',
            'My Month' => 'MyMonth',
            'Graph' => 'graph'
        );
        echo '<label for="NaNoStats-WidgetImg">NaNoWriMo Widget Image<br />
        To view to widgets by name go <a href="http://nanowrimo.org/en/widgets" target="_blank">here</a>.</label>';
        echo '<select name="NaNoStats-WidgetImg" id="NaNoStats-WidgetImg">';
        foreach($widgets as $title=>$url){
            $sel = $options['img'] == $url ? 'SELECTED':'';
            echo '<option value="'.$url.'" '.$sel.'>'.$title.'</option>';
        }
        echo '</select>';
    ?><br />
    <label for="NaNoStats-WidgetOptions">NaNoWriMo Widget Options</label><br />
    <?php
        $option = array(
            'wc' => 'Turn <strong>off</strong> word count',
            'days' => 'Turn "days left in nano" <strong>on</strong>',
            'pc' => 'Turn "percent complete" <strong>on</strong>'
        );
        foreach($option as $val => $desc){
            if($options['options'][$val]){
                $check = 'checked = "checked"';
            }else{
                $check = '';
            }
                echo '<input type="checkbox" name="NaNoStats-WidgetOptions['.$val.']" value="'.$val.'" '.$check.' /> '.$desc.'<br />';

        }
    ?>
    <input type="hidden" id="NaNoStats-Submit" name="NaNoStats-Submit" value="1" />
  </p>
<?php
}
 
function NaNoStats_init()
{
  register_sidebar_widget(__('NaNoStats'), 'widget_NaNoStats');
  register_widget_control(   'NaNoStats', 'NaNoStats_control', 300, 200 );     
}
add_action("plugins_loaded", "NaNoStats_init");
?>